#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "os.h"
#include "smadef.h"
#include "chandef.h"
#include "libyasdi.h"
#include "libyasdimaster.h"
#include "smadata_layer.h"

MODULE = yasdi		PACKAGE = yasdi

#p.11
void
yasdiMasterInitialize(char *cIniFileName, pDriverCount)
	unsigned long &pDriverCount;
	OUTPUT:
		pDriverCount

#p.12
void
yasdiMasterShutdown()

#p.13
unsigned long
pl_yasdiGetDeviceHandles(maxHandleCount)
	unsigned long maxHandleCount;
	CODE:
		unsigned long returnvalue;
		unsigned long Handles[maxHandleCount];
		AV *newarray;
		unsigned long i;
		newarray=get_av("yasdi::HandleArray", FALSE);
		returnvalue=GetDeviceHandles(Handles, maxHandleCount);
		for(i=0;i<maxHandleCount;i++) {
			av_push(newarray, newSVnv(Handles[i]));
		}
		RETVAL=returnvalue;
	OUTPUT:
		RETVAL

#p.13
SV *
pl_yasdiGetDeviceName(HandleID)
	unsigned long HandleID
	CODE:
		char DestBuffer[255];
		int ResultLength;
		ResultLength=GetDeviceName(HandleID, DestBuffer, sizeof(DestBuffer));
/*folgende Zeile nicht, da ResultLength entgegen der Doku nicht die Laenge, sondern 0 oder -1 zurueckliefert*/
/*		RETVAL=newSVpvn(DestBuffer, ResultLength);*/
		RETVAL=newSVpvn(DestBuffer, strlen(DestBuffer));
	OUTPUT:
		RETVAL

#p.14
unsigned long
pl_yasdiGetDeviceSN(HandleID)
	unsigned long HandleID
	CODE:
		int Result;
		unsigned long SNBuffer;
		Result=GetDeviceSN(HandleID, &SNBuffer);
		if (Result==-1) {
			RETVAL=0;
		} else {
			RETVAL=SNBuffer;
		}
	OUTPUT:
		RETVAL

#p.15
unsigned long
pl_yasdiGetChannelHandles(Handle, maxHandleCount, ChanType, ChanIndex)
	unsigned long Handle;
	unsigned long maxHandleCount;
	unsigned short ChanType;
	unsigned char ChanIndex;
	CODE:
		unsigned long returnvalue;
		unsigned long Handles[maxHandleCount];
		AV *newarray;
		unsigned long i;
		newarray=get_av("yasdi::ChannelHandles", FALSE);
		returnvalue=GetChannelHandles(Handle, Handles, maxHandleCount, ChanType, ChanIndex);
		for(i=0;i<maxHandleCount;i++) {
			av_push(newarray, newSVnv(Handles[i]));
		}
		RETVAL=returnvalue;
	OUTPUT:
		RETVAL

#p.16
unsigned long
FindChannelName(Handle, ChanName)
	unsigned long Handle;
	char *ChanName;
	OUTPUT:
		RETVAL

#p.18
unsigned long
pl_yasdiGetChannelValue(ChannelHandle, DeviceHandle, Value, ValueText)
	unsigned long ChannelHandle;
	unsigned long DeviceHandle;
	double Value;
	char ValueText;
	CODE:
		char ValueText0;
		char ValueText1[10];
		const unsigned long maxValueTextSize=10;
		const unsigned long maxChanValAge=10;
		RETVAL=GetChannelValue(ChannelHandle, DeviceHandle, &Value, ValueText1, 10, maxChanValAge);
/*printf(":%s:\n",&ValueText0);*/
/*		ValueText1=newSVpvn(&ValueText0, strlen(&ValueText0));*/
/*		strncpy(ValueText, ValueText1, strlen(ValueText1));*/
/*		ValueText=ValueText0;*/
		strncpy(&ValueText, ValueText1, strlen(ValueText1)+1);
/*		ValueText[strlen(ValueText1)]=0;*/
/*		ValueText=newSVpvn(ValueText1, strlen(ValueText1));*/
/*printf(":%s:%s:\n",&ValueText,ValueText1);*/
	OUTPUT:
		RETVAL
		Value
		ValueText

#p.24
int
yasdiDoMasterCmdEx(char *cmd, unsigned long Param1, unsigned long Param2, unsigned long Param3)
	OUTPUT:
		RETVAL

#p.25
unsigned long
pl_yasdiGetDriver(maxDriverIDs)
	int maxDriverIDs;
	CODE:
		unsigned long returnvalue;
		unsigned long DriverIDs[255];
		AV *newarray;
		unsigned long i;
		newarray=get_av("yasdi::DriverIDArray", FALSE);
		returnvalue=yasdiGetDriver(DriverIDs, maxDriverIDs);
		for(i=0;i<maxDriverIDs;i++) {
			av_push(newarray, newSVnv(DriverIDs[i]));
		}
		RETVAL=returnvalue;
	OUTPUT:
		RETVAL

#p.26
SV *
pl_yasdiGetDriverName(DriverID)
	unsigned long DriverID
	CODE:
		char DestBuffer[255];
		unsigned long ResultLength;
		ResultLength=yasdiGetDriverName(DriverID, DestBuffer, sizeof(DestBuffer));
		RETVAL=newSVpvn(DestBuffer, ResultLength);
	OUTPUT:
		RETVAL

#p.27
bool
yasdiSetDriverOnline(DriverID)
	unsigned long DriverID
	OUTPUT:
		RETVAL

#p.27
void
yasdiSetDriverOffline(DriverID)
	unsigned long DriverID

